library IEEE;
use IEEE.STD_LOGIC_1164.all;
use IEEE.STD_LOGIC_ARITH.all;

entity CMULT is
  port(AIN_I     : in  std_logic_vector(13 downto 0);  -- <14,6,t>
       AIN_Q     : in  std_logic_vector(13 downto 0);  -- <14,6,t>
       BIN_I     : in  std_logic_vector(9  downto 0);  -- <10,0,t>
       BIN_Q     : in  std_logic_vector(9  downto 0);  -- <10,0,t>
       YOUT_I    : out std_logic_vector(13 downto 0);  -- <14,6,t>
       YOUT_Q    : out std_logic_vector(13 downto 0)); -- <14,6,t>   
end CMULT;

architecture RTL of CMULT is

-- component declaration
component MULTAR
  port(in1     : in  std_logic_vector(13 downto 0);  -- <14,6,t>
       in2     : in  std_logic_vector(9  downto 0);  -- <10,0,t>
       outp    : out std_logic_vector(13 downto 0)); -- <14,6,t>
end component;

signal S1, S2, S3, S4 : std_logic_vector(13 downto 0);  -- <14,6,t>

begin

M1: MULTAR port map (AIN_I, BIN_I, S1);
M2: MULTAR port map (AIN_Q, BIN_Q, S2);
M3: MULTAR port map (AIN_Q, BIN_I, S3);
M4: MULTAR port map (AIN_I, BIN_Q, S4);

YOUT_I <= signed(S1) - signed(S2);
YOUT_Q <= signed(S3) + signed(S4);

end RTL;
