library IEEE;
use IEEE.STD_LOGIC_1164.all;
use IEEE.STD_LOGIC_ARITH.all;

entity MULTAR is
  port(in1     : in  std_logic_vector(13 downto 0);  -- <14,6,t>
       in2     : in  std_logic_vector(9  downto 0);  -- <10,0,t>
       outp    : out std_logic_vector(13 downto 0)); -- <14,6,t>
end MULTAR;

architecture RTL of MULTAR is

begin

  MULTAR : process(in1,in2)
    variable  var_tprod  : std_logic_vector(23 downto 0); -- <24,7,t>
    variable  var_round  : std_logic_vector(13 downto 0); -- <14,6,t>
  begin
    var_tprod := signed(in1) * signed(in2);

    if (var_tprod(8) = '1') then
        var_round := signed(var_tprod(22 downto 9)) + '1';
    else
        var_round := var_tprod(22 downto 9);
    end if;

    outp <= var_round;

  end process MULTAR;

end RTL;
